﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace C1SalesBook.Models
{
    internal class SalesDataSource
    {
        public static List<Sale> Load(string filename)
        {
            if (!File.Exists(filename))
            {
                throw new FileNotFoundException(
                    "Data file could not be found", filename);
            }

            var sales = System.Xml.Linq.XDocument.Load(filename).Root.Elements("Sale").Select(
                x => new Sale()
                {
                    Product = (string)x.Element("Product"),
                    Category = (string)x.Element("Category"),
                    Value = (double)x.Element("Value"),
                    Discount = (double)x.Element("Discount")
                });

            return sales.ToList();
        }
    }
}
