﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using C1SalesBook.Models;
using System.Windows.Input;
using System.Windows;

namespace C1SalesBook.ViewModels
{
    class MainViewModel
    {
        private ObservableCollection<Sale> sales = new ObservableCollection<Sale>();
        public ObservableCollection<Sale> Sales
        {
            get { return sales; }
        }

        public void LoadSales(string filename)
        {
            List<Sale> salesList = SalesDataSource.Load(filename);
            foreach (Sale sale in salesList)
            {
                sales.Add(sale);
            }
        }

        // ClearSalesBook Command
        private RelayCommand clearSalesBookCommand;

        public ICommand ClearSalesBookCommand
        {
            get
            {
                if (clearSalesBookCommand == null)
                {
                    clearSalesBookCommand = new RelayCommand(param => this.ClearSalesBook(), param => this.CanClearSalesBook());
                }
                return clearSalesBookCommand;
            }
        }

        // Execute method
        private void ClearSalesBook()
        {
            sales.Clear();
        }
        
        // Can execute method
        private bool CanClearSalesBook()
        {
            return sales.Count > 0;
        }

        // Exit command
        private RelayCommand exitCommand;
        public ICommand ExitCommand
        {
            get
            {
                if (exitCommand == null)
                {
                    exitCommand = new RelayCommand(param => this.Exit());
                }
                return exitCommand;
            }
        }

        private void Exit()
        {
            Application.Current.Shutdown();
        }

        // Print command
        private RelayCommand printCommand;
        public ICommand PrintCommand
        {
            get
            {
                if (printCommand == null)
                {
                    printCommand = new RelayCommand(param => this.Print(param));
                }
                return printCommand;
            }
        }

        private void Print(object param)
        {
            if (param != null)
            {
                C1.WPF.DataGrid.C1DataGrid grid = (C1.WPF.DataGrid.C1DataGrid)param;
                grid.Print("DocName", C1.WPF.DataGrid.ScaleMode.PageWidth, new Thickness(72), int.MaxValue);
            }
        }


    }
}
